/* GradeLabel.c generated by valac 0.56.14, the Vala compiler
 * generated from GradeLabel.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2021 Daniel Foré (https://github.com/danrabbit)
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
typedef struct _GradeLabelPrivate GradeLabelPrivate;
enum  {
	GRADE_LABEL_0_PROPERTY,
	GRADE_LABEL_LEVEL_PROPERTY,
	GRADE_LABEL_PASS_PROPERTY,
	GRADE_LABEL_NUM_PROPERTIES
};
static GParamSpec* grade_label_properties[GRADE_LABEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GradeLabel {
	GtkGrid parent_instance;
	GradeLabelPrivate * priv;
};

struct _GradeLabelClass {
	GtkGridClass parent_class;
};

struct _GradeLabelPrivate {
	GtkImage* icon;
	gchar* _level;
};

static gint GradeLabel_private_offset;
static gpointer grade_label_parent_class = NULL;

VALA_EXTERN GType grade_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GradeLabel, g_object_unref)
VALA_EXTERN GradeLabel* grade_label_new (const gchar* level);
VALA_EXTERN GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
VALA_EXTERN const gchar* grade_label_get_level (GradeLabel* self);
static void grade_label_set_level (GradeLabel* self,
                            const gchar* value);
VALA_EXTERN void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static GObject * grade_label_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void grade_label_finalize (GObject * obj);
static GType grade_label_get_type_once (void);
static void _vala_grade_label_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_grade_label_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
grade_label_get_instance_private (GradeLabel* self)
{
	return G_STRUCT_MEMBER_P (self, GradeLabel_private_offset);
}

GradeLabel*
grade_label_construct (GType object_type,
                       const gchar* level)
{
	GradeLabel * self = NULL;
#line 20 "../src/GradeLabel.vala"
	g_return_val_if_fail (level != NULL, NULL);
#line 21 "../src/GradeLabel.vala"
	self = (GradeLabel*) g_object_new (object_type, "height-request", 76, "width-request", 76, "level", level, "margin", 12, "margin-bottom", 24, NULL);
#line 20 "../src/GradeLabel.vala"
	return self;
#line 104 "GradeLabel.c"
}

GradeLabel*
grade_label_new (const gchar* level)
{
#line 20 "../src/GradeLabel.vala"
	return grade_label_construct (TYPE_GRADE_LABEL, level);
#line 112 "GradeLabel.c"
}

const gchar*
grade_label_get_level (GradeLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 9 "../src/GradeLabel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 9 "../src/GradeLabel.vala"
	_tmp0_ = self->priv->_level;
#line 9 "../src/GradeLabel.vala"
	result = _tmp0_;
#line 9 "../src/GradeLabel.vala"
	return result;
#line 128 "GradeLabel.c"
}

static void
grade_label_set_level (GradeLabel* self,
                       const gchar* value)
{
	gchar* old_value;
#line 9 "../src/GradeLabel.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/GradeLabel.vala"
	old_value = grade_label_get_level (self);
#line 9 "../src/GradeLabel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 142 "GradeLabel.c"
		gchar* _tmp0_;
#line 9 "../src/GradeLabel.vala"
		_tmp0_ = g_strdup (value);
#line 9 "../src/GradeLabel.vala"
		_g_free0 (self->priv->_level);
#line 9 "../src/GradeLabel.vala"
		self->priv->_level = _tmp0_;
#line 9 "../src/GradeLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, grade_label_properties[GRADE_LABEL_LEVEL_PROPERTY]);
#line 152 "GradeLabel.c"
	}
}

void
grade_label_set_pass (GradeLabel* self,
                      gboolean value)
{
#line 11 "../src/GradeLabel.vala"
	g_return_if_fail (self != NULL);
#line 12 "../src/GradeLabel.vala"
	if (value) {
#line 164 "GradeLabel.c"
		GtkImage* _tmp0_;
#line 13 "../src/GradeLabel.vala"
		_tmp0_ = self->priv->icon;
#line 13 "../src/GradeLabel.vala"
		g_object_set (_tmp0_, "icon-name", "object-select-symbolic", NULL);
#line 170 "GradeLabel.c"
	} else {
		GtkImage* _tmp1_;
#line 15 "../src/GradeLabel.vala"
		_tmp1_ = self->priv->icon;
#line 15 "../src/GradeLabel.vala"
		g_object_set (_tmp1_, "icon-name", "window-close-symbolic", NULL);
#line 177 "GradeLabel.c"
	}
#line 11 "../src/GradeLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, grade_label_properties[GRADE_LABEL_PASS_PROPERTY]);
#line 181 "GradeLabel.c"
}

static GObject *
grade_label_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GradeLabel * self;
	GtkLabel* level = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_;
	GtkImage* _tmp13_;
#line 30 "../src/GradeLabel.vala"
	parent_class = G_OBJECT_CLASS (grade_label_parent_class);
#line 30 "../src/GradeLabel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/GradeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRADE_LABEL, GradeLabel);
#line 31 "../src/GradeLabel.vala"
	_tmp0_ = self->priv->_level;
#line 31 "../src/GradeLabel.vala"
	_tmp1_ = g_strdup_printf ("<small><b>%s</b></small>", _tmp0_);
#line 31 "../src/GradeLabel.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/GradeLabel.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
#line 31 "../src/GradeLabel.vala"
	g_object_ref_sink (_tmp3_);
#line 31 "../src/GradeLabel.vala"
	_tmp4_ = _tmp3_;
#line 31 "../src/GradeLabel.vala"
	_g_free0 (_tmp2_);
#line 31 "../src/GradeLabel.vala"
	level = _tmp4_;
#line 32 "../src/GradeLabel.vala"
	_tmp5_ = level;
#line 32 "../src/GradeLabel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp5_, 20);
#line 33 "../src/GradeLabel.vala"
	_tmp6_ = level;
#line 33 "../src/GradeLabel.vala"
	g_object_set ((GtkWidget*) _tmp6_, "width-request", 76, NULL);
#line 34 "../src/GradeLabel.vala"
	_tmp7_ = level;
#line 34 "../src/GradeLabel.vala"
	gtk_label_set_use_markup (_tmp7_, TRUE);
#line 36 "../src/GradeLabel.vala"
	_tmp8_ = (GtkImage*) gtk_image_new ();
#line 36 "../src/GradeLabel.vala"
	g_object_ref_sink (_tmp8_);
#line 36 "../src/GradeLabel.vala"
	_g_object_unref0 (self->priv->icon);
#line 36 "../src/GradeLabel.vala"
	self->priv->icon = _tmp8_;
#line 37 "../src/GradeLabel.vala"
	_tmp9_ = self->priv->icon;
#line 37 "../src/GradeLabel.vala"
	g_object_set (_tmp9_, "icon-size", (gint) GTK_ICON_SIZE_LARGE_TOOLBAR, NULL);
#line 38 "../src/GradeLabel.vala"
	_tmp10_ = self->priv->icon;
#line 38 "../src/GradeLabel.vala"
	g_object_set (_tmp10_, "icon-name", "object-select-symbolic", NULL);
#line 40 "../src/GradeLabel.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 41 "../src/GradeLabel.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 41 "../src/GradeLabel.vala"
	gtk_style_context_add_class (_tmp11_, "grade");
#line 42 "../src/GradeLabel.vala"
	_tmp12_ = level;
#line 42 "../src/GradeLabel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp12_);
#line 43 "../src/GradeLabel.vala"
	_tmp13_ = self->priv->icon;
#line 43 "../src/GradeLabel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 30 "../src/GradeLabel.vala"
	_g_object_unref0 (level);
#line 30 "../src/GradeLabel.vala"
	return obj;
#line 275 "GradeLabel.c"
}

static void
grade_label_class_init (GradeLabelClass * klass,
                        gpointer klass_data)
{
#line 6 "../src/GradeLabel.vala"
	grade_label_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/GradeLabel.vala"
	g_type_class_adjust_private_offset (klass, &GradeLabel_private_offset);
#line 6 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_grade_label_get_property;
#line 6 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_grade_label_set_property;
#line 6 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->constructor = grade_label_constructor;
#line 6 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = grade_label_finalize;
#line 6 "../src/GradeLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRADE_LABEL_LEVEL_PROPERTY, grade_label_properties[GRADE_LABEL_LEVEL_PROPERTY] = g_param_spec_string ("level", "level", "level", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 6 "../src/GradeLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRADE_LABEL_PASS_PROPERTY, grade_label_properties[GRADE_LABEL_PASS_PROPERTY] = g_param_spec_boolean ("pass", "pass", "pass", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 298 "GradeLabel.c"
}

static void
grade_label_instance_init (GradeLabel * self,
                           gpointer klass)
{
#line 6 "../src/GradeLabel.vala"
	self->priv = grade_label_get_instance_private (self);
#line 307 "GradeLabel.c"
}

static void
grade_label_finalize (GObject * obj)
{
	GradeLabel * self;
#line 6 "../src/GradeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GRADE_LABEL, GradeLabel);
#line 7 "../src/GradeLabel.vala"
	_g_object_unref0 (self->priv->icon);
#line 9 "../src/GradeLabel.vala"
	_g_free0 (self->priv->_level);
#line 6 "../src/GradeLabel.vala"
	G_OBJECT_CLASS (grade_label_parent_class)->finalize (obj);
#line 322 "GradeLabel.c"
}

static GType
grade_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GradeLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) grade_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GradeLabel), 0, (GInstanceInitFunc) grade_label_instance_init, NULL };
	GType grade_label_type_id;
	grade_label_type_id = g_type_register_static (gtk_grid_get_type (), "GradeLabel", &g_define_type_info, 0);
	GradeLabel_private_offset = g_type_add_instance_private (grade_label_type_id, sizeof (GradeLabelPrivate));
	return grade_label_type_id;
}

GType
grade_label_get_type (void)
{
	static volatile gsize grade_label_type_id__once = 0;
	if (g_once_init_enter (&grade_label_type_id__once)) {
		GType grade_label_type_id;
		grade_label_type_id = grade_label_get_type_once ();
		g_once_init_leave (&grade_label_type_id__once, grade_label_type_id);
	}
	return grade_label_type_id__once;
}

static void
_vala_grade_label_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	GradeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRADE_LABEL, GradeLabel);
#line 6 "../src/GradeLabel.vala"
	switch (property_id) {
#line 6 "../src/GradeLabel.vala"
		case GRADE_LABEL_LEVEL_PROPERTY:
#line 6 "../src/GradeLabel.vala"
		g_value_set_string (value, grade_label_get_level (self));
#line 6 "../src/GradeLabel.vala"
		break;
#line 363 "GradeLabel.c"
		default:
#line 6 "../src/GradeLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/GradeLabel.vala"
		break;
#line 369 "GradeLabel.c"
	}
}

static void
_vala_grade_label_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	GradeLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GRADE_LABEL, GradeLabel);
#line 6 "../src/GradeLabel.vala"
	switch (property_id) {
#line 6 "../src/GradeLabel.vala"
		case GRADE_LABEL_LEVEL_PROPERTY:
#line 6 "../src/GradeLabel.vala"
		grade_label_set_level (self, g_value_get_string (value));
#line 6 "../src/GradeLabel.vala"
		break;
#line 6 "../src/GradeLabel.vala"
		case GRADE_LABEL_PASS_PROPERTY:
#line 6 "../src/GradeLabel.vala"
		grade_label_set_pass (self, g_value_get_boolean (value));
#line 6 "../src/GradeLabel.vala"
		break;
#line 395 "GradeLabel.c"
		default:
#line 6 "../src/GradeLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 6 "../src/GradeLabel.vala"
		break;
#line 401 "GradeLabel.c"
	}
}

